#include-once

#include <File.au3>
#include <Misc.au3>
#include <GUIConstants.au3>
#include <GUITreeView.au3>
#include <TristateTreeViewLib.au3>

; TV functions
Global $nMsg, $down, $szPath, $current
Global $sStateIconFile = @TempDir & "\CheckBox.bmp"

; Hittest infos
Global Const $TVHT_ONITEMICON = 0x0002
Global Const $TVHT_ONITEMLABEL = 0x0004
Global Const $TVHT_ONITEMBUTTON = 0x0010
Global Const $TVHT_ONITEM = BitOR($TVHT_ONITEMICON, $TVHT_ONITEMLABEL, $TVHT_ONITEMSTATEICON)

Global $nCtrls = 0
Global $hCurItem = 0
Global $nTreeView
Global $FoldersOnly


; $iFoldersOnly    1 Display folders only, 0 (default) display folders and files.

Func _OpenFileFolderDialog($sTitle, $sMsg, $iFoldersOnly = 0, $iParent = '')
	Local $arDrives = DriveGetDrive("ALL")
	Local $szOldPath = ''
	Local $szCurrentPath = EnvGet('SystemDrive')
	Local $nFirstItem = 0
	Local $nLastItem = 0
	
	If IsHWnd($iParent) Then WinSetState($iParent, "", @SW_DISABLE)
	
	If $iFoldersOnly = -1 Then $iFoldersOnly = 0
	$FoldersOnly = $iFoldersOnly
	FileInstall('CheckBox.bmp', @TempDir & '\')
	$hGui = GUICreate($sTitle, 374, 398, -1, -1, _
		BitOR($WS_SYSMENU, $WS_CAPTION, $WS_POPUPWINDOW, $WS_BORDER, $WS_CLIPSIBLINGS), -1, $iParent)
	GUICtrlCreateLabel($sMsg, 8, 8, 241, 17)
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	$nTreeView = GUICtrlCreateTreeView(6, 26, 361, 337, BitOR($TVS_HASBUTTONS, $TVS_HASLINES, $TVS_LINESATROOT, $TVS_DISABLEDRAGDROP, $TVS_SHOWSELALWAYS, $TVS_CHECKBOXES, $WS_GROUP, $WS_TABSTOP, $WS_BORDER, $WS_CLIPSIBLINGS))
	GUICtrlSetImage(-1, "shell32.dll", 4, 4) 	;
	GUICtrlSetImage(-1, "shell32.dll", 5, 2) 	;
	GUICtrlSetImage(-1, "shell32.dll", 7) 	; Removable
	GUICtrlSetImage(-1, "shell32.dll", 8) 	; Fixed
	GUICtrlSetImage(-1, "shell32.dll", 9) 	; Network
	GUICtrlSetImage(-1, "shell32.dll", 11) 	; CD-ROM
	$OK = GUICtrlCreateButton("OK", 214, 368, 75, 25, 0)
	$Cancel = GUICtrlCreateButton("Cancel", 294, 368, 75, 25, 0)
	LoadStateImage ($nTreeView, $sStateIconFile)
	GUISetState(@SW_SHOW)
	FillTreeRoot($arDrives)
	UpdateWindow($nTreeView)
	
	While 1
		$nMsg = GUIGetMsg(1)
		$arInfo = GUIGetCursorInfo()
		
		If WinActive($hGui) And IsArray($arInfo) And $arInfo[4] = $nTreeView And $arInfo[2] Then
			$nFlag = 0
			$hItem = TV_Hittest($nTreeView, $nFlag)
			If BitAND($nFlag, $TVHT_ONITEMBUTTON) Or BitAND($nFlag, $TVHT_ONITEM) Then
				GUISetState(@SW_LOCK)
				CheckTreeFill($nTreeView, $hItem)
				GUISetState(@SW_UNLOCK)
			EndIf
			$hItem = GUICtrlSendMsg($nTreeView, $TVM_GETNEXTITEM, $TVGN_CARET, 0)
			$szCurrentPath = GetTreePath($nTreeView, $hItem, "\")
			If $szOldPath <> $szCurrentPath Then
				$szOldPath = $szCurrentPath
				GUISetState(@SW_LOCK)
				For $i = $nFirstItem To $nLastItem
					GUICtrlDelete($i)
				Next
				GUISetState(@SW_UNLOCK)
				$nFirstItem = 0
				$nLastItem = 0
				$nOldItem = 0
				GUICtrlSetCursor($nTreeView, 2)
			EndIf
		ElseIf _IsPressed("6B") And ControlGetFocus($hGui) = "SysTreeView321" Then
			$hItem = GUICtrlSendMsg($nTreeView, $TVM_GETNEXTITEM, $TVGN_CARET, 0)
			CheckTreeFill($nTreeView, $hItem)
		EndIf
		
		Switch $nMsg[0]
			Case $GUI_EVENT_CLOSE, $Cancel
				If $nMsg[1] = $hGui Or $nMsg[0] = $Cancel Then ExitLoop
			Case $OK
				MsgBox(64, "Selected Folders and Files", _
					"This is the section of the script that I need help. I will like to return " & _
					"an array with the full path of all selected folders and files." & @CRLF & _
					"If nothing was selected return an empty string.")
		EndSwitch
	WEnd
	
	If IsHWnd($iParent) Then WinSetState($iParent, "", @SW_ENABLE)
	GUIDelete($hGui)
EndFunc   ;==>_OpenFileFolderDialog

Func CheckTreeFill($nCtrl, $hItem)
	If $hItem > 0 Then
		$hChild = GUICtrlSendMsg($nTreeView, $TVM_GETNEXTITEM, $TVGN_CHILD, $hItem)
		If $hChild > 0 Then
			$szText = GetItemText($nTreeView, $hChild)
			If $szText == "" Then
				$szPath = GetTreePath($nTreeView, $hItem, "\")
				If StringRight($szPath, 1) == "\" Then $szPath = StringTrimRight($szPath, 1)
				GUICtrlSetCursor($nTreeView, 1)
				FillTree($szPath, $hItem, $hChild)
				GUICtrlSetCursor($nTreeView, 2)
			EndIf
		EndIf
	EndIf
EndFunc   ;==>CheckTreeFill

Func FillTree($szPath, $hParent = 0, $hDelete = 0)
	Local $hSearch, $szFile, $nChildren, $s_DirExist
	If $hDelete > 0 Then
		GUICtrlSendMsg($nTreeView, $TVM_DELETEITEM, 0, $hDelete)
		SetItemChildren($hParent)
	EndIf
	Local $s_AnswerFile = @TempDir & '\au3.txt'
	$s_Switches1 = "/ad /b /on"
	$s_Switches2 = "/a-d /b /on"
	$szPath = FileGetShortName($szPath)
	If (StringRight($szPath, 1) == "\") Then $szPath = StringTrimRight($szPath, 1)
	$s_DirExist = 0
	$s_Command = 'dir ' & $szPath & '\* ' & $s_Switches1 & ' > "' & $s_AnswerFile & '"'
	RunWait(@ComSpec & ' /c ' & $s_Command, '', @SW_HIDE)
	$s_Command = 'dir ' & $szPath & '\* ' & $s_Switches2 & ' >> "' & $s_AnswerFile & '"'
	If Not $FoldersOnly Then RunWait(@ComSpec & ' /c ' & $s_Command, '', @SW_HIDE)
	If Not StringRight($szPath, 1) = ":" Then $s_DirExist = 1
	$hSearch = FileOpen($s_AnswerFile, 0)
	While 1
		$szFile = FileReadLine($hSearch)
		If @error = -1 Then ExitLoop
		$nChildren = 0
		If GetSubFolder($szPath & "\" & $szFile) Then $nChildren = 1
		$nIcon = 0
		$szIconFile = $szPath & "\" & $szFile
		FileGetIcon($szIconFile, $nIcon, $szFile)
		$IsDir = StringInStr(FileGetAttrib($szPath & "\" & $szFile), "D")
		$hItem = InsertItem($szFile, $hParent, $hCurItem, $nChildren)
		If $nChildren = 1 Then InsertDummyItem($nTreeView, $hItem)
		If Not $IsDir Then
			Opt('ExpandEnvStrings', 1)
			$szIconFile = StringReplace($szIconFile, '"', '')
			$ret = _GUICtrlTreeViewSetIcon($nTreeView, $hItem, $szIconFile, $nIcon)
			Opt('ExpandEnvStrings', 1)
		EndIf
		$nCtrls += 1
	WEnd
	FileClose($hSearch)
	FileDelete($s_AnswerFile)
EndFunc   ;==>FillTree

Func GetSubFolder($szPath)
	Local $hSearch, $szFile, $nChildren = 0
	If DriveStatus($szPath & '\') = 'notready' Then Return $nChildren
	$hSearch = FileFindFirstFile($szPath & "\*.*")
	If $hSearch = -1 Then Return $nChildren
	$szFile = FileFindNextFile($hSearch)
	If @error Then Return $nChildren
	$nChildren = 1
	FileClose($hSearch)
	Return $nChildren
EndFunc   ;==>GetSubFolder

Func FillTreeRoot($arDrives)
	Local $hSearch, $szFile, $nChildren, $szDriveLabel
	$hParent = 0
	GUICtrlSetCursor($nTreeView, 1)
	
	For $i = 1 To $arDrives[0]
		$nChildren = 0
		If GetSubFolder($arDrives[$i]) Then $nChildren = 1
		$szType = DriveGetType($arDrives[$i])
		Switch $szType
			Case "Removable"
				$iImage = 2
				$iSelectedImage = 2
			Case "Fixed"
				$iImage = 3
				$iSelectedImage = 3
			Case "Network"
				$iImage = 4
				$iSelectedImage = 4
			Case "CDROM"
				$iImage = 5
				$iSelectedImage = 5
			Case Else
				$iImage = 0
				$iSelectedImage = 0
		EndSwitch
		If $szType = "Removable" Then
			$szText = "Removable"
		ElseIf $szType = "Network" Then
			$szLabel = DriveMapGet($arDrives[$i])
			$nPos = StringInStr($szLabel, "\", 0, -1)
			$szText = StringRight($szLabel, StringLen($szLabel) - $nPos) & " on """ & _
				StringTrimLeft(StringLeft($szLabel, $nPos - 1), 2) & """"
		Else
			$szText = DriveGetLabel($arDrives[$i])
		EndIf
		$szDriveLabel = $szText & " (" & StringUpper($arDrives[$i]) & ")"
		$hItem = InsertItem($szDriveLabel, $hParent, $hCurItem, $nChildren, $iImage, $iSelectedImage)
		If $nChildren = 1 Then InsertDummyItem($nTreeView, $hItem)
	Next
	$hItem = GUICtrlSendMsg($nTreeView, $TVM_GETNEXTITEM, $TVGN_ROOT, 0)
	GUICtrlSendMsg($nTreeView, $TVM_SELECTITEM, $TVGN_CARET, $hItem)
	
	GUICtrlSetCursor($nTreeView, 2)
EndFunc   ;==>FillTreeRoot

Func InsertItem($szText, $hParent, $hInsertAfter, $nChildren, $iImage = 0, $iSelectedImage = 1)
	$pszText = DllStructCreate("char[260]")
	DllStructSetData($pszText, 1, $szText)
	$tvItem = TVITEM()
	$tvInsertStruct = DllStructCreate("int;int;int[10]")
	If $hCurItem = 0 Then
		$hInsertAfter = $TVI_FIRST
	Else
		$hInsertAfter = $hCurItem
	EndIf
	DllStructSetData($tvInsertStruct, 1, $hParent)
	DllStructSetData($tvInsertStruct, 2, $hInsertAfter)
	DllStructSetData($tvInsertStruct, 3, $tvItem)
	$hItem = GUICtrlSendMsg($nTreeView, $TVM_INSERTITEM, 0, DllStructGetPtr($tvInsertStruct))
	If $hItem > 0 Then
		$hCurItem = $hItem
		DllStructSetData($tvItem, 1, BitOR($TVIF_TEXT, $TVIF_IMAGE, $TVIF_SELECTEDIMAGE))
		DllStructSetData($tvItem, 2, $hItem)
		DllStructSetData($tvItem, 5, DllStructGetPtr($pszText))
		DllStructSetData($tvItem, 7, $iImage)
		DllStructSetData($tvItem, 8, $iSelectedImage)
		GUICtrlSendMsg($nTreeView, $TVM_SETITEM, 0, DllStructGetPtr($tvItem))
	EndIf
	Return $hItem
EndFunc   ;==>InsertItem

Func InsertDummyItem($nCtrl, $hItem)
	InsertItem("", $hItem, $hCurItem, 0)
EndFunc   ;==>InsertDummyItem

Func TVITEM()
	Return DllStructCreate("uint;int;uint;uint;ptr;int;int;int;int;int")
EndFunc   ;==>TVITEM

Func GetItemText($nCtrl, $hItem)
	Local $szText = "", $pszText, $tvItem
	$pszText = DllStructCreate("char[260]")
	$tvItem = TVITEM()
	DllStructSetData($tvItem, 1, $TVIF_TEXT)
	DllStructSetData($tvItem, 2, $hItem)
	DllStructSetData($tvItem, 5, DllStructGetPtr($pszText))
	DllStructSetData($tvItem, 6, 260)
	GUICtrlSendMsg($nTreeView, $TVM_GETITEM, 0, DllStructGetPtr($tvItem))
	$szText = DllStructGetData($pszText, 1)
	Return $szText
EndFunc   ;==>GetItemText

Func GetTreePath($nCtrl, $hItem, $szSepChar)
	Local $szPath = "", $hParent, $hWnd, $szText
	While $hItem > 0
		$szText = GetItemText($nCtrl, $hItem)
		$hParent = GUICtrlSendMsg($nCtrl, $TVM_GETNEXTITEM, $TVGN_PARENT, $hItem)
		If $hParent = 0 Then $szText = StringRight(StringTrimRight($szText, 1), 2)
		$szPath = $szText & $szSepChar & $szPath
		$hItem = $hParent
	WEnd
	Return $szPath
EndFunc   ;==>GetTreePath

Func SetItemChildren($hItem, $nFlag = 1)
	Local $tvItem
	$tvItem = TVITEM()
	DllStructSetData($tvItem, 1, $TVIF_CHILDREN)
	DllStructSetData($tvItem, 2, $hItem)
	DllStructSetData($tvItem, 9, $nFlag)
	GUICtrlSendMsg($nTreeView, $TVM_SETITEM, 0, DllStructGetPtr($tvItem))
EndFunc   ;==>SetItemChildren

Func UpdateWindow($nCtrl)
	$hWnd = ControlGetHandle("", "", $nCtrl)
	$rect = DllStructCreate("int;int;int;int")
	DllCall("user32.dll", "int", "InvalidateRect", "hwnd", $hWnd, "int", 0, "int", 0)
EndFunc   ;==>UpdateWindow

Func TV_Hittest($nCtrl, ByRef $nFlag)
	$hItem = 0
	$point = DllStructCreate("int;int")
	DllCall("user32.dll", "int", "GetCursorPos", "ptr", DllStructGetPtr($point))
	$hWnd = ControlGetHandle("", "", $nCtrl)
	DllCall("user32.dll", "int", "ScreenToClient", "hwnd", $hWnd, "ptr", DllStructGetPtr($point))
	$tvHit = DllStructCreate("int[2];uint;int")
	DllStructSetData($tvHit, 1, DllStructGetData($point, 1), 1)
	DllStructSetData($tvHit, 1, DllStructGetData($point, 2), 2)
	If GUICtrlSendMsg($nCtrl, $TVM_HITTEST, 0, DllStructGetPtr($tvHit)) Then
		$nFlag = DllStructGetData($tvHit, 2)
		$hItem = DllStructGetData($tvHit, 3)
	EndIf
	Return $hItem
EndFunc   ;==>TV_Hittest

Func FileGetIcon(ByRef $szIconFile, ByRef $nIcon, $szFile)
	Dim $szRegDefault = "", $szDefIcon = ""
	$szExt = StringMid($szFile, StringInStr($szFile, '.', 0, -1))
	If $szExt = '.lnk' Then
		$details = FileGetShortcut($szIconFile)
		$szIconFile = $details[0]
		$szExt = StringMid($details[0], StringInStr($details[0], '.', 0, -1))
	EndIf
	$szRegDefault = RegRead("HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\" & $szExt, "ProgID")
	If $szRegDefault = "" Then $szRegDefault = RegRead("HKCR\" & $szExt, "")
	If $szRegDefault <> "" Then $szDefIcon = RegRead("HKCR\" & $szRegDefault & "\DefaultIcon", "")
	If $szDefIcon = "" Then $szRegDefault = RegRead("HKCR\" & $szRegDefault & "\CurVer", "")
	If $szRegDefault <> "" Then $szDefIcon = RegRead("HKCR\" & $szRegDefault & "\DefaultIcon", "")
;ConsoleWrite('File: ' & $szIconFile & ' ' & 'HKCUR\' & $szRegDefault & ' Icon: ' & $szDefIcon & @CRLF)
	If $szDefIcon = "" Then
		$szIconFile = "shell32.dll"
	ElseIf $szDefIcon <> "%1" Then
		$arSplit = StringSplit($szDefIcon, ",")
		If IsArray($arSplit) Then
			$szIconFile = $arSplit[1]
			If $arSplit[0] > 1 Then $nIcon = $arSplit[2]
		Else
			Return 0
		EndIf
	EndIf
	Return 1
EndFunc   ;==>FileGetIcon